package de.uniulm.inkombio.pareto;

public class Solution {
	/**
	 * Vector of objective function values of this solution
	 */
	public final double[] values;
	
	/**
	 * Average minimum free energy of the two structures 
	 */
	public final double mfe;

	public final double mfe_a;
	public final double mfe_b;
	
	public final String sequence_a;
	public final String sequence_b;
	public final String structure;
	
	public Solution(double[] values, String sequence_a, String sequence_b, String structure, double mfe_a, double mfe_b) {
		this.values = values;
		this.sequence_a = sequence_a;
		this.sequence_b = sequence_b;
		this.structure = structure;
		this.mfe_a = mfe_a;
		this.mfe_b = mfe_b;
		this.mfe = (mfe_a + mfe_b) / 2;
	}
	
	public static Solution max(Solution a, Solution b, double[] d) {
		double sum_a=0.0;
		double sum_b=0.0;
		for (int i=0; i<d.length; i++) {
			sum_a += a.values[i]*d[i];
			sum_b += b.values[i]*d[i];
		}
		if (sum_a>sum_b) return a; else return b;
	}
	
}