
#include <iostream>

#include "dpmatrix.hpp"

dpmatrix::dpmatrix() : n1(0), n2(0), M(NULL) {}

dpmatrix::dpmatrix(int n1, int n2) : n1(n1), n2(n2), M(NULL) {
	if (n1>0) {
		M = new std::vector<target>*[n1];
		for (int i=0; i<n1; i++) {
			M[i] = new std::vector<target>[n2];
		}
	}
}

dpmatrix::dpmatrix (const dpmatrix &d) : n1(0), n2(0) {
	*this = d;
}

dpmatrix::~dpmatrix() {
	if (n1>0) {
		for (int j=0; j<n1; j++) {
			delete[] M[j];
		}
		delete[] M;
	}
}	

std::vector<target>* dpmatrix::operator[](size_t i) const {
	if (i>=n1) std::cerr << "ERROR i=" << i << " n1="<<n1<<" n2="<<n2<<std::endl;
	return M[i];
}

dpmatrix& dpmatrix::operator=(const dpmatrix &d) {
	if (n1==d.n1 && n2==d.n2) {
		for (int i=0; i<n1; i++) {
			for (int j=0; j<n2; j++) {
				M[i][j] = d[i][j];
			}
		}
	} else {
		if (n1>0) {
			for (int j=0; j<n1; j++) {
				delete[] M[j];
			}
			delete[] M;
		}
		n1 = d.n1;
		n2 = d.n2;
		M = new std::vector<target>*[n1];
		for (int i=0; i<n1; i++) {
			M[i] = new std::vector<target>[n2];
			for (int j=0; j<n2; j++) {
				M[i][j] = d[i][j];
			}
		}
	}
	return *this;
}

void dpmatrix::clear() {
	for (int i=0; i<n1; i++) {
		for (int j=0; j<n2; j++) {
			M[i][j].clear();
		}
	}
}
