
// wrapper for pf_fold() in Vienna RNAlib
// compiles with gcc with the parameters -fopenmp -I/usr/include/ViennaRNA -lRNA 

#include "fold_vars.h"
#include "part_func.h"
#include "fold.h"

#define minread 0.0001

void fill_bppm_RNAfold(const char* seq, int length, double **bppm) {
	int i,j;
	FLT_OR_DBL *pr;
	noLonelyPairs = 1;
	pf_fold(seq, 0);
	pr = export_bppm();
	for (i=1; i<=length; i++) {
		for (j=i; j<=length; j++) {
			if (pr[iindx[i]-j]>minread) {
				bppm[i][j] = (double)pr[iindx[i]-j];
			}
		}
	}
	free_pf_arrays();
}

double RNAeval(const char* sequence, const char* structure) {
	return energy_of_structure(sequence, structure, 0);
}
